VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.1#0"; "COMDLG32.OCX"
Begin VB.Form fConvert 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "VSOCX 5->6 Conversion Utility"
   ClientHeight    =   2805
   ClientLeft      =   3570
   ClientTop       =   3105
   ClientWidth     =   5685
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2805
   ScaleWidth      =   5685
   ShowInTaskbar   =   0   'False
   Begin MSComDlg.CommonDialog dlg 
      Left            =   3120
      Top             =   2100
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   327681
   End
   Begin VB.ListBox lst 
      Height          =   2460
      IntegralHeight  =   0   'False
      ItemData        =   "Convert.frx":0000
      Left            =   120
      List            =   "Convert.frx":0007
      TabIndex        =   1
      Top             =   150
      Width           =   2535
   End
   Begin VB.CommandButton cmd 
      Caption         =   "Select Project..."
      Height          =   365
      Left            =   3930
      TabIndex        =   0
      Top             =   2250
      Width           =   1365
   End
   Begin VB.Label Label1 
      BackStyle       =   0  'Transparent
      Caption         =   "This is an unsupported tool. Make sure you BACK UP the original project before proceeding."
      Height          =   795
      Index           =   1
      Left            =   2850
      TabIndex        =   3
      Top             =   870
      Width           =   2685
      WordWrap        =   -1  'True
   End
   Begin VB.Label Label1 
      BackStyle       =   0  'Transparent
      Caption         =   "This utility will convert VideoSoft VSOCX 5.0  Visual Basic projects for use with VideoSoft VSOCX 6.0 ."
      Height          =   645
      Index           =   0
      Left            =   2850
      TabIndex        =   2
      Top             =   180
      Width           =   2745
      WordWrap        =   -1  'True
   End
End
Attribute VB_Name = "fConvert"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Project:      Convert
' Copyright:    Videosoft, 1998.
'               All rights reserved.
' Date:         23 March 1998
'
' Remarks
'
' This application is provided "as-is".  It may be freely distributed
' in compiled or source form.  However, if any part of the code is
' published in the original source form, the publication should
' acknowledge the origin of the code at VideoSoft.
'
' "To do" items:
'
' Right now, the conversion utility handles only the control
' declarations -- it does not handle code yet.
'
' Notes:
'
' We have changed the behavior of the Align property with
' respect to control ZOrder. This means that forms with
' controls aligned to the top and sides will look a little
' different. It doesn't seem worthwhile fixing, although
' it could be done by shuffling the controls while writing
' the out.
'
' The project converts property values that had the old
' defaults to the new defaults (e.g. ChildSpacing). This
' may alter the look of some projects, but should not cause
' any problems otherwise. It also doesn't seem worthwhile
' changing this behavior, since the new defautls are just as
' reasonable as the old ones.
'

Option Explicit
Option Compare Text

' Conversion constants
'
Const FRMREFOLD = "Object = ""{2037E3AD-18D6-101C-8158-221E4B551F8E}#5.0#0""; ""VSOCX32.OCX"""
Const FRMREFNEW = "Object = ""{3B008041-905A-11D1-B4AE-444553540000}#1.0#0""; ""VSOCX6.OCX"""

Const VBPREFOLD = "Object={2037E3AD-18D6-101C-8158-221E4B551F8E}#5.0#0; VSOCX32.OCX"
Const VBPREFNEW = "Object={3B008041-905A-11D1-B4AE-444553540000}#1.0#0; VSOCX6.OCX"

Const ELDECOLD = "Begin VsOcxLib.VideoSoftElastic"
Const ELDECNEW = "Begin vsOcx6LibCtl.vsElastic"

Const TABDECOLD = "Begin VsOcxLib.VideoSoftIndexTab"
Const TABDECNEW = "Begin vsOcx6LibCtl.vsIndexTab"

Const AWKDECOLD = "Begin VsOcxLib.VideoSoftAwk"
Const AWKDECNEW = "Begin vsOcx6LibCtl.vsAwk"

Sub ConvertControl(s$)
    Dim bElastic%, bIndexTab%, bAwk%
    
    ' keep track of the control type
    ' we will need this to filter the properties
    '
    If StringReplace(s, ELDECOLD, ELDECNEW) Then
        bElastic = True
    ElseIf StringReplace(s, TABDECOLD, TABDECNEW) Then
        bIndexTab = True
    ElseIf StringReplace(s, AWKDECOLD, AWKDECNEW) Then
        bAwk = True
    End If
    
    ' write control declaration
    '
    Print #2, s
    
    ' loop converting the control
    '
    While Not EOF(1)
    
        ' get a line
        '
        Line Input #1, s
        
        ' handle nested controls using recursive call
        '
        If Left(Trim(s), 6) = "Begin " Then
            ConvertControl s
        
        ' at the end of the control, bail out
        '
        ElseIf Trim(s) = "End" Then
            Print #2, s
            Exit Sub
        
        ' filter properties according to the control type we're
        ' converting.
        ' the Elastic and the IndexTab need some conversions;
        ' the Awk doesn't.
        '
        Else
            If bElastic Then
                FilterPropElastic s
            ElseIf bIndexTab Then
                FilterPropIndexTab s
            Else
                Print #2, s
            End If
        End If
    Wend
    
    ' we should never get here
    '
    Debug.Print "unexpected EOF"

End Sub

Sub ConvertForm(ByVal pth$, fn$)
    Dim s$
    
    ' if the file has a path spec, don't prepend the project path
    '
    If InStr(fn, "\") = 0 Then pth = ""
    
    ' make a backup copy of the file
    ' we just append '.bak' to the file name
    ' the file will have two extensions, which is OK in Win32
    '
    FileCopy pth & fn, pth & fn & ".bak"
    
    ' open files to read (backup) and write (converted)
    '
    Open pth & fn & ".bak" For Input As #1
    Open pth & fn For Output As #2
    
    ' scan the file
    '
    While Not EOF(1)
        
        ' read a line
        '
        Line Input #1, s
        
        ' convert object reference
        '
        If StringReplace(s, FRMREFOLD, FRMREFNEW) Then
            Print #2, s
        
        ' convert controls
        '
        ElseIf Left(Trim(s), 6) = "Begin " Then
            ConvertControl s
        
        ' just copy whatever else there is
        '
        Else
            Print #2, s
        End If
    Wend
    
    ' done with this form, close both files
    '
    Close #1
    Close #2
End Sub

Sub FilterPropElastic(s)
    Dim i%
    
    '----------------------------------------------------
    ' remove some properties
    '
    If InStr(s, "_Version ") > 0 Then Exit Sub
    If InStr(s, "_ExtentX ") > 0 Then Exit Sub
    If InStr(s, "_ExtentY ") > 0 Then Exit Sub
    If InStr(s, "_StockProps ") > 0 Then Exit Sub
    If InStr(s, "ConvInfo ") > 0 Then Exit Sub
    If InStr(s, "BevelInner ") > 0 Then Exit Sub
    If InStr(s, "BevelOuter ") > 0 Then Exit Sub
    If InStr(s, "BevelDir ") > 0 Then Exit Sub
    If InStr(s, "BevelInnerWidth ") > 0 Then Exit Sub
    If InStr(s, "BevelOuterWidth ") > 0 Then Exit Sub
    If InStr(s, "BevelChildren ") > 0 Then Exit Sub
    If InStr(s, "AccessKey ") > 0 Then Exit Sub
    If InStr(s, "ShadowColor ") > 0 Then Exit Sub
    If InStr(s, "QuickPaint ") > 0 Then Exit Sub
    If InStr(s, "ButtonState ") > 0 Then Exit Sub
    If InStr(s, "CornerColor ") > 0 Then Exit Sub
    If InStr(s, "BevelOuterDir ") > 0 Then Exit Sub
    If InStr(s, "ShowFocusRect ") > 0 Then Exit Sub
    If InStr(s, "ShowOutline ") > 0 Then Exit Sub

    '----------------------------------------------------
    ' convert others
    '
    
    ' the button styles have been removed
    '
    If InStr(s, "Style ") > 0 Then
        i = GetPropValue(s)
        If i <= 2 Then Print #2, s
        Exit Sub
    End If

    '----------------------------------------------------
    ' write out whatever is left as-is
    '
    Print #2, s

End Sub


Sub FilterPropIndexTab(s)
    Dim i%
    
    '----------------------------------------------------
    ' remove some properties
    '
    If InStr(s, "_Version ") > 0 Then Exit Sub
    If InStr(s, "_ExtentX ") > 0 Then Exit Sub
    If InStr(s, "_ExtentY ") > 0 Then Exit Sub
    If InStr(s, "_StockProps ") > 0 Then Exit Sub
    If InStr(s, "ConvInfo ") > 0 Then Exit Sub
    If InStr(s, "New3D ") > 0 Then Exit Sub

    '----------------------------------------------------
    ' convert others
    '
    
    ' the styles have been changed
    '
    If InStr(s, "Style ") > 0 Then
        i = GetPropValue(s)
        
        ' write the converted style
        s = Space(Len(s) - Len(LTrim(s))) & "Style = " & i \ 2
        Print #2, s
        
        ' write the appearance (3D for odd styles)
        s = Space(Len(s) - Len(LTrim(s))) & "Appearance = "
        If i Mod 2 = 0 Then
            s = s & "0 'Flat"
        Else
            s = s & "1 '3D"
        End If
        Print #2, s
        
        ' done with this property
        Exit Sub
    End If

    '----------------------------------------------------
    ' write out whatever is left as-is
    '
    Print #2, s

End Sub


Function GetPropValue(ByVal s$) As Variant
    
    ' parse a property assignment string,
    ' return portion after the equals sign.
    '
    If InStr(s, "=") > 0 Then
        GetPropValue = Trim(Mid(s, InStr(s, "=") + 1))
    End If

End Function

Function StringReplace(s$, find$, repl$) As Boolean
    Dim i%
    
    ' find target string, return False if failed
    '
    i = InStr(s, find)
    If i = 0 Then Exit Function
    
    ' make all the replacements
    '
    While i > 0
        s = Left(s, i - 1) & repl & Mid(s, i + Len(find))
        i = InStr(i + 1, s, find)
    Wend
    
    ' return True to indicate replacements were made
    '
    StringReplace = True
    
End Function

Private Sub cmd_Click()
    Dim prj$, pth$, s$, i%, j%
    
    ' get VB project name
    '
    dlg.CancelError = False
    dlg.filename = ""
    dlg.DefaultExt = "vbp"
    dlg.Filter = "Visual Basic Projecs (*.vbp)|*.vbp"
    dlg.Flags = cdlOFNFileMustExist
    dlg.ShowOpen
    prj = dlg.filename
    If prj = "" Then Exit Sub
    lst.Clear
    
    ' parse project path and file name
    '
    i = 0
    While InStr(i + 1, prj, "\") > 0
        i = InStr(i + 1, prj, "\")
    Wend
    pth = Left(prj, i)
    prj = Mid(prj, i + 1)
    
    ' read the whole project file
    '
    Open pth & prj For Binary As #1
    s = Input(LOF(1), 1)
    Close #1
    
    ' replace library references
    ' if the project does not reference VSOCX5, then we have
    ' nothing to do. warn the user and bail out.
    '
    i = StringReplace(s, VBPREFOLD, VBPREFNEW)
    If i = False Then
        MsgBox "This project does not use VSOCX5. Conversion cancelled.", vbInformation
        Exit Sub
    End If
    
    ' make a backup copy of the project file
    ' we just append '.bak' to the file name
    ' the file will have two extensions, which is OK in Win32
    '
    FileCopy prj, prj & ".bak"
    
    ' write out updated project file
    '
    Open prj For Output As #1
    Print #1, s
    Close #1
    lst.AddItem prj & "... OK"
    Print #9, ""
    Print #9, Format$(Now, "general date") & " " & prj & "... OK"
    
    ' find all forms in the project
    '
    i = 1
    Do
        i = InStr(i, s, "Form=")
        If i = 0 Then Exit Do
        If Mid(s, i + 5, 1) <> """" Then
            j = InStr(i, UCase$(s), ".FRM")
            If j <> 0 Then lst.AddItem Mid(s, i + 5, j - i - 1)
        End If
        i = i + 1
    Loop
    
    ' process form files
    '
    For i = 1 To lst.ListCount - 1
        ConvertForm pth, lst.List(i)
        lst.ListIndex = i
        lst.List(i) = lst.List(i) & "... OK"
        Print #9, Format$(Now, "general date") & " " & lst.List(i)
        Refresh
        DoEvents
    Next
    
    ' find all UserControls in the project
    '
    lst.Clear
    i = 1
    Do
        i = InStr(i, s, "UserControl=")
        If i = 0 Then Exit Do
        If Mid(s, i + 12, 1) <> """" Then
            j = InStr(i, UCase$(s), ".ctl")
            If j <> 0 Then lst.AddItem Mid(s, i + 12, j - (i + 7) - 1)
        End If
        i = i + 1
    Loop
    
    ' process UserControl files
    '
    For i = 1 To lst.ListCount - 1
        ConvertForm pth, lst.List(i)
        lst.ListIndex = i
        lst.List(i) = lst.List(i) & "... OK"
        Print #9, Format$(Now, "general date") & " " & lst.List(i)
        Refresh
        DoEvents
    Next
    
    lst.AddItem "Conversion successful"

End Sub

Private Sub Form_Load()
    
    ' Clear our file list
    lst.Clear

    ' Open the log
    Open App.Path & "\Convert.log" For Append As #9
    
End Sub

Private Sub Form_Unload(Cancel As Integer)

    Close #9

End Sub
